include \masm32\include\masm32rt.inc

floatx$ MACRO arg, digitfactor:=<1000>
  fld arg
  push digitfactor
  call floatx
  EXITM <eax>
ENDM

floatnix$ MACRO arg, nosucharg
  push offset arg
  pop eax
  call print_float
  mov eax, offset NullString	; use a dummy - the routine prints itself
  EXITM <eax>
ENDM

CodeSize MACRO algo, mode
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s	; sub eax, offset algo sounds good but no good with symbols!
  print str$(eax), 9, " bytes for &algo&", 13, 10
  popad
ENDM

.code
r8a	REAL8	12.3456
r8b	REAL8	1234.56
r8c	REAL8	1234567.89012345678
r8d	REAL8	-0.00123456789		; low negative number
r8e	REAL8	1.23456
r8f	REAL8	-123.456	; negative number

r4a	REAL4	12.3456
r4b	REAL4	1234.56
r4c	REAL4	1234567.89012345678
r4d	REAL4	-0.00123456789		; low negative number
r4e	REAL4	1.23456
r4f	REAL4	-123.456	; negative number

start:	mov ebx, esp
	RayMod=0	; set to 1 to test it
	print "nixeagle float, Ray's mod = "
	print str$(RayMod), ":", 13, 10
	print floatnix$(r8a), 13, 10
	print floatnix$(r8b), 13, 10
	print floatnix$(r8c, 100000000), 13, 10
	print floatnix$(r8d, 10000000), 13, 10
	print floatnix$(r8e), 13, 10
	print floatnix$(r8f), 13, 10, 10

	print "jj float, Real8:", 13, 10
	print floatx$(r8a), 13, 10
	print floatx$(r8b), 13, 10
	print floatx$(r8c, 1000000000), 9, "9 digits set", 13, 10
	print floatx$(r8d, 10000000), 9, "7 digits set", 13, 10
	print floatx$(r8e), 13, 10
	print floatx$(r8f), 13, 10, 10

	print "jj float, Real4:", 13, 10
	print floatx$(r4a), 13, 10
	print floatx$(r4b), 13, 10
	print floatx$(r4c, 1000000000), 9, "9 digits set", 13, 10
	print floatx$(r4d, 10000000), 9, "7 digits set", 13, 10
	print floatx$(r4e), 13, 10
	print floatx$(r4f), 13, 10, 10

	sub ebx, esp
	.if !Zero?
		print chr$(10,10,10, "stack diff=")
		print str$(ebx), 13, 10
	.endif
	CodeSize print_float
	CodeSize floatx
	inkey chr$(0)
	exit
.data?
NullString	dd ?
flBuffer	db 20 dup(?)
.code
x1000	REAL4 1000.0
  ; bits		54321098
  MbDown64 =	10000111b
  MbNear64 =	10000011b

floatx_s:
floatx proc 		; arg1=digits
  push edi
  stack equ <dword ptr [esp]>	; example is -123.456
  mov edi, offset flBuffer
  push edi			; save offset flBuffer
  push 256*MbDown64+255	; create a slot with control word
  fnstcw word ptr [esp+2]	; save a copy to hiword
  fldcw word ptr [esp]	; set new control word
  push edi			; create another slot
  fist stack			; stack=123
  cmp byte ptr [esp+3], 0	; negative REAL8?
  .if Sign?
	fchs	; make ST(0) positive
	fist stack	; save again
	mov al, "-"	; handle a negative number
	stosb
  .endif
  fisub stack		; ST0=0.456
  invoke dwtoa, [esp+4], edi
  add edi, len(edi)
  mov byte ptr [esp+5], MbNear64
  pop edx
  fldcw word ptr [esp]	; set new control word
  push edi			; pBuffer for dwtoa
  push stack[20]	; digits		; we need to use a dirty trick here:
  fimul stack		; e.g. for 123.007654  --->  ST0=7.654
  fiadd stack		; ST0=1007.xxx
  fistp stack		; [esp]=arg for dwtoa
  call dwtoa		; invoke dwtoa, digits, edi=pBuffer
  mov byte ptr [edi], "."	; dirty hack: overwrite the leading "1"
  fldcw word ptr [esp+2]	; restore old control word
  pop edx
  pop eax			; return start of buffer
  pop edi
  retn 4
floatx endp
floatx_endp:

;; assume pointer to float is in eax
;; float is REAL8
print_float_s:	; for CodeSize
print_float PROC
    push ebx
    push ecx
    push edx
    fld REAL8 PTR [eax]            ; Load, store as integer, and print
	; Ray
;	int 3
if RayMod
    fist DWORD PTR [esp+4]        ; the integer portion of the number.
    fisub dword ptr[esp+4]        ; ****** leaves only the fractional part on the FPU ******
    mov eax, [esp+4]
    print ustr$(eax)

    print "."                      ; Print decimal point marker.

    mov ebx, 3
  TheLoop:
    mov ecx, 10
    mov [esp+4], ecx
    
    fimul DWORD PTR [esp+4]
    fist DWORD PTR [esp+4]
    fisub dword ptr[esp+4]
    mov edx, [esp+4]
    print ustr$(edx)

    dec ebx
    jnz TheLoop
else
    fist DWORD PTR [esp+4]        ; the integer portion of the number.
    mov eax, [esp+4]
    print ustr$(eax)

    print "."                      ; Print decimal point marker.

    mov ebx, 3
  TheLoop:
    ;;; now prepare to print first 3 digits after the decimal point.
    mov ecx, 10
    mov [esp+4], ecx
    
    fimul DWORD PTR [esp+4]
    fist DWORD PTR [esp+4]
    mov eax, [esp+4]
    mov ecx, 10
    xor edx, edx
    div ecx
    ;; we want remainder, which is in edx.
    print ustr$(edx)

    dec ebx
    jns TheLoop
endif

    fistp DWORD PTR [esp+4]
    pop edx
    pop ecx
    pop ebx
    ret
print_float ENDP
print_float_endp:

end start
